<%@ Page Language="C#" AutoEventWireup="true" %>
<%@ Register Assembly="System.Web.Extensions, Version=1.0.61025.0, Culture=neutral, PublicKeyToken=31bf3856ad364e35"
    Namespace="System.Web.UI" TagPrefix="asp" %>
<%@ Import Namespace="LogicBase.Core.Models.Workflow" %>
<%@ Import Namespace="LogicBase.Core" %>    
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<script runat="server">

    WorkflowManagementServiceImpl workflowService = new WorkflowManagementServiceImpl();
    protected void Page_Load(object sender, EventArgs e)
    {
        try
        {
            if (!IsPostBack)
            {
                if(Request["InactiveWorkflowType"]!=null)
                {
                    LoadInactiveWorkflowDetails();
                    updtPnlStats.Visible = false;
                    pnlTaskList.Visible = false;
                    updPnlTaskDetails.Visible = false;
                    pnlCurrentProcesses.Visible = false;
                    pnlExecutionHistory.Visible = false;
                    pnlInactiveWorkflow.Visible = true;
                }
                else if (Request["TaskID"] != null)
                {
                    LoadTaskDetails();
                    updtPnlStats.Visible = false;
                    pnlTaskList.Visible = false;
                    updPnlTaskDetails.Visible = true;
                    pnlCurrentProcesses.Visible = false;
                    pnlExecutionHistory.Visible = false;
                    pnlInactiveWorkflow.Visible = false;
                }
                else if (Request["HistoryTrackingID"] != null)
                {
                    updtPnlStats.Visible = false;
                    pnlTaskList.Visible = false;
                    updPnlTaskDetails.Visible = false;
                    pnlCurrentProcesses.Visible = false;
                    pnlExecutionHistory.Visible = true;
                    pnlInactiveWorkflow.Visible = false;
                    
                    WorkStatus statusHistoryItems = workflowService.TrackStatus(Request["HistoryTrackingID"]);
                    if (statusHistoryItems.StatusItems != null && statusHistoryItems.StatusItems.Length > 0)
                    {
                        gvExecutionHistory.DataSource = statusHistoryItems.StatusItems;
                        gvExecutionHistory.DataBind();
                    }
                    lblHistoryTrackingID.Text = Request["HistoryTrackingID"];
                }
                
                else
                {
                    if (Request["AbortTrackingID"] != null)
                    {
                        AbortWorkflow();
                    }
                    pnlInactiveWorkflow.Visible = false;
                    updtPnlStats.Visible = false;
                    pnlTaskList.Visible = true;
                    updPnlTaskDetails.Visible = false;
                    pnlCurrentProcesses.Visible = false;
                    pnlExecutionHistory.Visible = false;
                    if (Request["TrackingID"] != null)
                    {
                        LoadTrackingIDTasks();
                    }
                    else if (Request["taskAssignmentType"] != null)
                    {
                        if (Request["taskAssignmentType"] == "Unassigned")
                        {
                            LoadUnassignedTasks();
                        }
                        else if (Request["taskAssignmentType"] == "CurrentProcesses")
                        {
                            LoadAllTasks();
                            updtPnlStats.Visible = false;
                            pnlTaskList.Visible = false;
                            updPnlTaskDetails.Visible = false;
                            pnlCurrentProcesses.Visible = true;
                        }
                        else
                        {
                            TaskAssignmentType taskAssignmentType =
                                (TaskAssignmentType)
                                Enum.Parse(typeof(TaskAssignmentType), Request["taskAssignmentType"]);
                            string name = Request["name"];
                            LoadTasks(name, taskAssignmentType);
                        }
                    }
                    else
                    {
                        LoadStats();
                        pnlTaskList.Visible = false;
                        updPnlTaskDetails.Visible = false;
                        pnlCurrentProcesses.Visible = false;
                        updtPnlStats.Visible = true;
                    }
                }
            }
            lblErrorMessage.Text = "";
        }
        catch(Exception ex)
        {
            lblErrorMessage.Text = "Error :" + ex.ToString();
        }
    }

    private void AbortWorkflow()
    {
        try
        {            
            workflowService.AbortWorkflowProcess(Request["AbortTrackingID"]);
        }
        catch
        {
        }
    }
    private void LoadInactiveWorkflowDetails()
    {
        InactiveWorkflowType inactiveWorkflowType =
            (InactiveWorkflowType)Enum.Parse(typeof(InactiveWorkflowType), Request["InactiveWorkflowType"]);
        InactiveWorkflowHeader[] headers = workflowService.GetInactiveWorkflowWorkflows(inactiveWorkflowType, false);

        lblInactiveWorkflowType.Text = Request["InactiveWorkflowType"];
        
        gvInactiveWorkflow.DataSource = headers;
        gvInactiveWorkflow.DataBind();
        
    }

    private void LoadTrackingIDTasks()
    {
        TaskAssignmentStructure[] trackingIDTasks = workflowService.GetTasksForProcess(Request["TrackingID"]);
        gvTaskList.DataSource = trackingIDTasks;
        gvTaskList.DataBind();
        lblTaskAssignmentType.Text = "Tracking ID";
        lblName.Text = Request["TrackingID"];
        hlBackToCurrentProcesses.Visible = true;
    }

    private void LoadAllTasks()
    {
        WorkflowProcess[] processes = workflowService.GetCurrentProcesses();
        gvCurrentProcesses.DataSource = processes;
        gvCurrentProcesses.DataBind(); 
    }

    private void LoadTaskDetails()
    {
        if (Request["TaskID"] != null)
        {
            TaskAssignmentStructure taskAssignmentStructure = workflowService.GetTaskAssignment(Request["TaskID"]);
            lblTaskName.Text = taskAssignmentStructure.TaskName;
            lblTaskDescription.Text = taskAssignmentStructure.Description;
            lblComponentName.Text = taskAssignmentStructure.ComponentName;
            lblTaskType.Text = taskAssignmentStructure.TaskTypeID;
            lblTaskID.Text = taskAssignmentStructure.TaskID;
            lblProject.Text = taskAssignmentStructure.CreatedBy;
            lblTaskPriority.Text = taskAssignmentStructure.TaskPriority.ToString();
            lblModelName.Text = taskAssignmentStructure.ModelName;
            lblTrackingID.Text = taskAssignmentStructure.TrackingID;
            
            if (taskAssignmentStructure.DueDate != null)
            {
                lblDueDate.Text = taskAssignmentStructure.DueDate.ToString();
            }
            if(taskAssignmentStructure.LateDate != null)
            {
                lblLateDate.Text = taskAssignmentStructure.LateDate.ToString();
            }

            gvResponses.DataSource = taskAssignmentStructure.Responses;
            gvResponses.DataBind();

            gvAssignments.DataSource = taskAssignmentStructure.Assignments;
            gvAssignments.DataBind();

            ddlAssignmentType.DataSource = Enum.GetNames(typeof(TaskAssignmentType));
            ddlAssignmentType.DataBind();

            if (Request["TrackingID"] != null)
            {
                hlBackToList.NavigateUrl = "?TrackingID=" + Request["TrackingID"];
            }
            else
            {
                hlBackToList.NavigateUrl = "?taskAssignmentType=" + Request["TaskAssignmentType"] + "&Name=" +
                                           Request["Name"];
            }

            gvTriggers.DataSource = workflowService.GetTriggersForWorkflowItem(Request["TaskID"]);
            gvTriggers.DataBind();
        }

    }

    private void LoadTasks(string name, TaskAssignmentType taskAssignmentType)
    {
        TaskAssignmentStructure[] tasks = workflowService.GetTasks(name, taskAssignmentType);
        if (tasks != null && tasks.Length > 0)
        {
            gvTaskList.DataSource = tasks;
            gvTaskList.DataBind();
        }

        lblTaskAssignmentType.Text = taskAssignmentType.ToString();
        lblName.Text = name;
    }

    private void LoadUnassignedTasks()
    {
        TaskAssignmentStructure[] tasks = workflowService.GetUnassignedTasks();
        if (tasks != null && tasks.Length > 0)
        {
            gvTaskList.DataSource = tasks;
            gvTaskList.DataBind();
        }

        lblTaskAssignmentType.Text = "Unassigned";
        lblName.Text = "";
    }

    private void LoadStats()
    {
        
        // Load the Counts
        hlCurrentProcessCount.Text = workflowService.GetWorkflowProcessCount().ToString();
        hlUnassignedTasksCount.Text = workflowService.GetUnassignedTasksCount().ToString();
        // Hyperlink the Counts
        
        // Load the User Assignments
        Assignment[] userAssignments = workflowService.GetAssignments(TaskAssignmentType.User);
        if (userAssignments != null && userAssignments.Length > 0)
        {
            gvUserAssignments.DataSource = userAssignments;
            gvUserAssignments.DataBind();
            lblUserNone.Visible = false;
        }
        else
        {
            lblUserNone.Visible = true;
        }

        
        // Load the Group Assignments
        Assignment[] groupAssignments = workflowService.GetAssignments(TaskAssignmentType.Group);
        if (groupAssignments != null && groupAssignments.Length > 0)
        {
            gvGroupAssignments.DataSource = groupAssignments;
            gvGroupAssignments.DataBind();
            lblGroupNone.Visible = false;
        }
        else
        {
            lblGroupNone.Visible = true;
        }
        // Load the Permission Assignments
        Assignment[] permissionAssignments = workflowService.GetAssignments(TaskAssignmentType.Permission);
        if (permissionAssignments != null && permissionAssignments.Length > 0)
        {
            gvPermissionAssignments.DataSource = permissionAssignments;
            gvPermissionAssignments.DataBind();
            lblPermissionNone.Visible = false;
        }
        else
        {
            lblPermissionNone.Visible = true;
        }
        // Load the Org Unit Assignments
        Assignment[] orgAssignments = workflowService.GetAssignments(TaskAssignmentType.OrgUnit);
        if (orgAssignments != null && orgAssignments.Length > 0)
        {
            gvOrganizationAssignments.DataSource = orgAssignments;
            gvOrganizationAssignments.DataBind();
            lblOrganizationNone.Visible = false;
        }
        else
        {
            lblOrganizationNone.Visible = true;
        }
        // Load the Work Queue Assignments
        Assignment[] queueAssignments = workflowService.GetAssignments(TaskAssignmentType.Queue);
        if (queueAssignments != null && queueAssignments.Length > 0)
        {
            gvQueueAssignments.DataSource = queueAssignments;
            gvQueueAssignments.DataBind();
            lblQueueNone.Visible = false;
        }
        else
        {
            lblQueueNone.Visible = true;
        }
        
        // Load the Other Counts
        if(chkErrorCount.Checked)
        {
            hlErrorCount.Text = workflowService.GetInactiveWorkflowCount(InactiveWorkflowType.Exception).ToString();
            hlErrorCount.NavigateUrl = "?InactiveWorkflowType=" + InactiveWorkflowType.Exception.ToString();
        }
        else
        {
            hlErrorCount.Text = "Check box to the Left to get count";
        }
        
        if(chkCheckPointCount.Checked)
        {
            hlCheckPointCount.Text =
                workflowService.GetInactiveWorkflowCount(InactiveWorkflowType.Checkpoint).ToString();
            hlCheckPointCount.NavigateUrl = "?InactiveWorkflowType=" + InactiveWorkflowType.Checkpoint.ToString();
        }
        else
        {
            hlCheckPointCount.Text = "Check box to the Left to get count";
        }
        
        if(chkArchiveCount.Checked)
        {
            hlArchiveCount.Text = workflowService.GetInactiveWorkflowCount(InactiveWorkflowType.Archive).ToString();
            hlArchiveCount.NavigateUrl = "?InactiveWorkflowType=" + InactiveWorkflowType.Archive.ToString();
        }
        else
        {
            hlArchiveCount.Text = "Check box to the Left to get count";
        }
        
    }

    protected void gvTaskList_RowDataBound(object sender, GridViewRowEventArgs e)
    {
        if(e.Row.RowType == DataControlRowType.DataRow)
        {
            HyperLink hlView = (HyperLink)e.Row.FindControl("hlViewLink");
            if (Request["TrackingID"] != null)
            {
                hlView.NavigateUrl += "&TrackingID=" + Request["TrackingID"];
            }
            else
            {
                hlView.NavigateUrl += "&Name=" + Request["Name"] + "&TaskAssignmentType=" +
                                      Request["TaskAssignmentType"];
            }
        }
    }

    protected void gvAssignments_RowDeleting(object sender, GridViewDeleteEventArgs e)
    {
        string taskId = Request["TaskID"];
        string name = gvAssignments.Rows[e.RowIndex].Cells[1].Text;
        TaskAssignmentType taskAssignmentType = (TaskAssignmentType)Enum.Parse(typeof(TaskAssignmentType), gvAssignments.Rows[e.RowIndex].Cells[0].Text);
        workflowService.RemoveAssignment(taskId,name,taskAssignmentType);
        LoadTaskDetails();
        
    }

    protected void gvAssignments_RowDataBound(object sender, GridViewRowEventArgs e)
    {
        if(e.Row.RowType == DataControlRowType.DataRow)
        {
            ((LinkButton)e.Row.Cells[2].Controls[0]).Attributes["onclick"] = "javascript:return confirm('Are you sure you want to remove this Assignment?')";
        }
    }

    protected void btnAdd_Click(object sender, EventArgs e)
    {
        if(!String.IsNullOrEmpty(txtName.Text))
        {
            string taskID = Request["TaskID"];
            workflowService.AddAssignment(taskID, txtName.Text, (TaskAssignmentType)Enum.Parse(typeof(TaskAssignmentType), ddlAssignmentType.SelectedValue));
            LoadTaskDetails();
            ddlAssignmentType.SelectedIndex = -1;
            txtName.Text = "";
        }
    }

    protected void gvCurrentProcesses_RowDataBound(object sender, GridViewRowEventArgs e)
    {
        if(e.Row.RowType == DataControlRowType.DataRow)
        {
            string trackingID = e.Row.Cells[1].Text;
            e.Row.Cells[2].Text = workflowService.GetTasksForProcess(trackingID).Length.ToString();            
        }
    }

    protected void refreshTimer_Tick(object sender, EventArgs e)
    {
        if (!chkStopPolling.Checked)
        {
            if (pnlProcessAndAssignment.Visible)
            {
                if (Request["TaskID"] == null && Request["TrackingID"] == null && Request["taskAssignmentType"] == null)
                {
                    try
                    {
                        LoadStats();
                        lblErrorMessage.Text = "";
                    }
                    catch (Exception ex)
                    {
                        lblErrorMessage.Text = "Error :" + ex.ToString();
                    }
                }
            }
        }
    }

    protected void gvExecutionHistory_RowDataBound(object sender, GridViewRowEventArgs e)
    {
        if(e.Row.RowType == DataControlRowType.DataRow)
        {
            WorkStatusItem statusItem = (WorkStatusItem)e.Row.DataItem;
            e.Row.Cells[0].Text = statusItem.When.ToString();
            e.Row.Cells[1].Text = statusItem.ComponentName;
            e.Row.Cells[2].Text = statusItem.EventType;
            e.Row.Cells[3].Text = statusItem.FinishPath;
            e.Row.Cells[4].Text = statusItem.Description;
        }
    }

    protected void btnRefresh_Click(object sender, EventArgs e)
    {
        try
        {
            LoadStats();
            lblErrorMessage.Text = "";
        }
        catch(Exception ex)
        {
            lblErrorMessage.Text = "Error :" + ex.ToString();
        }
    }

    protected void gvTriggers_RowDeleting(object sender, GridViewDeleteEventArgs e)
    {
        workflowService.RemoveTrigger(Request["TaskID"], e.RowIndex);
        LoadTaskDetails();
    }

    protected void lbRemoveAllTriggers_Click(object sender, EventArgs e)
    {
        workflowService.RemoveAllTriggers(Request["TaskID"]);
        LoadTaskDetails();
    }

    protected void btnPostpone_Click(object sender, EventArgs e)
    {
        if(!String.IsNullOrEmpty(txtTimeoutTime.Text))
        {
            workflowService.PostponeTimeout(Request["TaskID"], DateTime.Parse(txtTimeoutTime.Text));
            LoadTaskDetails();
        }
    }

    protected void gvTriggers_RowCommand(object sender, GridViewCommandEventArgs e)
    {
        if(e.CommandName=="ChangeTiming")
        {
          if(!String.IsNullOrEmpty(txtNewTriggerTime.Text))
          {
              workflowService.ChangeTriggerTiming(Request["TaskID"],int.Parse((string)e.CommandArgument),DateTime.Parse(txtNewTriggerTime.Text));
              LoadTaskDetails();
          }
        }
    }

    protected void gvInactiveWorkflow_RowDataBound(object sender, GridViewRowEventArgs e)
    {
        if (e.Row.RowType == DataControlRowType.DataRow)
        {
            InactiveWorkflowHeader header = (InactiveWorkflowHeader) e.Row.DataItem;
            e.Row.Cells[0].Text = header.ArchiveDateTime.ToString();
            e.Row.Cells[1].Text = header.Details;
            e.Row.Cells[2].Text = header.LastComponentName;
            e.Row.Cells[3].Text = header.LastModelName;
            e.Row.Cells[4].Text = header.IsRestartable.ToString();
        }
    }
</script>

<html xmlns="http://www.w3.org/1999/xhtml" >
<head id="Head1" runat="server">
    <title>Workflow Management</title>
<style type="text/css">
h2
{
font-family:Verdana;
}
.titleTD
{
font-family:Verdana;
background-color: lightblue;
font-weight:bold;
}
td
{
font-family:Verdana;
font-size:10pt;
}
.fieldTitleTD
{
font-weight:bold;
}
</style>    
    
</head>

<body>
    <form id="form1" runat="server">
        <asp:ScriptManager ID="ScriptManager1" runat="server">
        </asp:ScriptManager>
        <table cellpadding="3" style="width: 100%">
            <tr>
                <td align=center style="width: 820px">
                     <h2>Workflow Management Statistics</h2></td>
            </tr>
        </table>
        <asp:Timer ID="refreshTimer" runat="server" Interval="10000" OnTick="refreshTimer_Tick" >
        </asp:Timer>
        <asp:UpdatePanel ID="updtPnlStats" runat="server" RenderMode="Inline">
        <ContentTemplate>
            <table cellpadding="3" style="width: 100%">
                <tr>
                    <td>
                    <asp:Panel runat="server" ID="pnlProcessAndAssignment" Visible="true">
                    <table cellpadding="5" cellspacing="1" width="100%" style="font-size: 10pt; font-family: Verdana;border:solid 1px black">
                        <tr >
                            <td colspan="2" align="center" style="border-bottom:solid 1px black">
                            <asp:Label ID="lblErrorMessage" runat="server" ForeColor="red"></asp:Label>
                            </td>
                        </tr>
                        <tr >
                            <td colspan="2" align="right" style="border-bottom:solid 1px black">
                            <asp:LinkButton runat="server" ID="btnRefresh" Text="Refresh" OnClick="btnRefresh_Click"></asp:LinkButton>
                            </td>
                        </tr>
                        <tr>
                            <td width="150px" class="titleTD">
                            <asp:HyperLink ID="hlCurrentProcess" runat="server" Text="Current Processes :"></asp:HyperLink>
                            </td>                            
                            <td >
                            <asp:HyperLink ID="hlCurrentProcessCount" runat="server"></asp:HyperLink>&nbsp;
                            <asp:HyperLink ID="hlViewCurrentProcesses" runat="server" Text="[View]" NavigateUrl="?taskAssignmentType=CurrentProcesses"></asp:HyperLink>
                            </td>
                        </tr>
                        <tr>
                            <td width="150px" class="titleTD">
                            <asp:HyperLink ID="hlUnassignedTasks" runat="server" Text="Unassigned Tasks :"></asp:HyperLink>
                            </td>                            
                            <td>
                            <asp:HyperLink ID="hlUnassignedTasksCount" runat="server"></asp:HyperLink>&nbsp;
                            <asp:HyperLink ID="hlViewUnassignedTasks" runat="server" Text="[View]" NavigateUrl="?taskAssignmentType=Unassigned"></asp:HyperLink>
                            </td>
                        </tr>
                        <tr>
                            <td class="titleTD" width="150">
                                Error Count :</td>
                            <td>
                                <asp:CheckBox ID="chkErrorCount" runat="server" />
                                <asp:HyperLink ID="hlErrorCount" runat="server">[hlErrorCount]</asp:HyperLink></td>
                        </tr>
                        <tr>
                            <td class="titleTD" width="150">
                                Checkpoint Failed Count :</td>
                            <td>
                                <asp:CheckBox ID="chkCheckPointCount" runat="server" />
                                <asp:HyperLink ID="hlCheckPointCount" runat="server">[hlCheckPointCount]</asp:HyperLink></td>
                        </tr>
                        <tr>
                            <td class="titleTD" width="150">
                                Archive Count :</td>
                            <td>
                                <asp:CheckBox ID="chkArchiveCount" runat="server" />
                                <asp:HyperLink ID="hlArchiveCount" runat="server">[hlArchiveCount]</asp:HyperLink></td>
                        </tr>
                         <tr>
                            <td class="titleTD" width="150">
                                Stop Polling :</td>
                            <td>
                                <asp:CheckBox ID="chkStopPolling" runat="server" />
                        </tr>
                    </table>
        </asp:Panel>
                    </td>
                </tr>
                <tr>
                    <td>
                     <table cellpadding="5" cellspacing="1" width="100%" style="font-size: 10pt; font-family: Verdana;border:solid 1px black">
                        <tr>
                        <td align=center class="titleTD">
                        User Assignments
                        </td>
                        </tr>
                        <tr>
                        <td>
                            <asp:GridView ID="gvUserAssignments" runat="server" AutoGenerateColumns="False" CellPadding="4"
                                EmptyDataText="None" ForeColor="#333333" GridLines="None" Width="100%">
                                <FooterStyle BackColor="#507CD1" Font-Bold="True" ForeColor="White" />
                                <Columns>
                                    <asp:HyperLinkField DataNavigateUrlFields="Name" DataNavigateUrlFormatString="?name={0}&amp;taskAssignmentType=User "
                                        DataTextField="Name" HeaderText="Name">
                                        <ItemStyle Width="80%" />
                                        <HeaderStyle Width="80%" HorizontalAlign="Left" />
                                    </asp:HyperLinkField>
                                    <asp:HyperLinkField DataNavigateUrlFields="Name" DataNavigateUrlFormatString="?name={0}&amp;taskAssignmentType=User "
                                        DataTextField="Count" HeaderText="Count">
                                        <ItemStyle HorizontalAlign="Center" Width="20%" />
                                        <HeaderStyle HorizontalAlign="Center" Width="20%" />
                                    </asp:HyperLinkField>
                                </Columns>
                                <RowStyle BackColor="#EFF3FB" />
                                <EditRowStyle BackColor="#2461BF" />
                                <SelectedRowStyle BackColor="#D1DDF1" Font-Bold="True" ForeColor="#333333" />
                                <PagerStyle BackColor="#2461BF" ForeColor="White" HorizontalAlign="Center" />
                                <HeaderStyle BackColor="#507CD1" Font-Bold="True" ForeColor="White" />
                                <AlternatingRowStyle BackColor="White" />
                            </asp:GridView>
                            <asp:Label ID="lblUserNone" runat="server" Text="None"></asp:Label></td>
                        </tr>
                     </table>
                    </td>
                </tr>
                <tr>
                    <td>
                     <table cellpadding="5" cellspacing="1" width="100%" style="font-size: 10pt; font-family: Verdana;border:solid 1px black">
                        <tr>
                        <td align=center class="titleTD">
                            Group Assignments
                        </td>
                        </tr>
                        <tr>
                        <td>
                            <asp:GridView ID="gvGroupAssignments" runat="server" AutoGenerateColumns="False"
                                CellPadding="4" EmptyDataText="None" ForeColor="#333333" GridLines="None" Width="100%">
                                <Columns>
                                    <asp:HyperLinkField DataNavigateUrlFields="Name" DataNavigateUrlFormatString="?name={0}&amp;taskAssignmentType=Group "
                                        DataTextField="Name" HeaderText="Name">
                                        <ItemStyle HorizontalAlign="Left" Width="80%" />
                                        <HeaderStyle HorizontalAlign="Left" Width="80%" />
                                    </asp:HyperLinkField>
                                    <asp:HyperLinkField DataNavigateUrlFields="Name" DataNavigateUrlFormatString="?name={0}&amp;taskAssignmentType=Group "
                                        DataTextField="Count" HeaderText="Count">
                                        <ItemStyle HorizontalAlign="Center" Width="20%" />
                                        <HeaderStyle HorizontalAlign="Center" Width="20%" />
                                    </asp:HyperLinkField>
                                </Columns>
                                <FooterStyle BackColor="#507CD1" Font-Bold="True" ForeColor="White" />
                                <RowStyle BackColor="#EFF3FB" />
                                <EditRowStyle BackColor="#2461BF" />
                                <SelectedRowStyle BackColor="#D1DDF1" Font-Bold="True" ForeColor="#333333" />
                                <PagerStyle BackColor="#2461BF" ForeColor="White" HorizontalAlign="Center" />
                                <HeaderStyle BackColor="#507CD1" Font-Bold="True" ForeColor="White" />
                                <AlternatingRowStyle BackColor="White" />
                            </asp:GridView><asp:Label ID="lblGroupNone" runat="server" Text="None"></asp:Label>
                        </td>
                        </tr>
                     </table>
                    </td>
                </tr>
                <tr>
                    <td>
                     <table cellpadding="5" cellspacing="1" width="100%" style="font-size: 10pt; font-family: Verdana;border:solid 1px black">
                        <tr>
                        <td align=center class="titleTD">
                            Permission Assignments
                        </td>
                        </tr>
                        <tr>
                        <td>
                            <asp:GridView ID="gvPermissionAssignments" runat="server" AutoGenerateColumns="False"
                                CellPadding="4" EmptyDataText="None" ForeColor="#333333" GridLines="None" Width="100%">
                                <FooterStyle BackColor="#507CD1" Font-Bold="True" ForeColor="White" />
                                <Columns>
                                    <asp:HyperLinkField DataNavigateUrlFields="Name" DataNavigateUrlFormatString="?name={0}&amp;taskAssignmentType=Permission"
                                        DataTextField="Name" HeaderText="Name">
                                        <ItemStyle Width="80%" />
                                        <HeaderStyle Width="80%" HorizontalAlign="Left" />
                                    </asp:HyperLinkField>
                                    <asp:HyperLinkField DataNavigateUrlFields="Name" DataNavigateUrlFormatString="?name={0}&amp;taskAssignmentType=Permission"
                                        DataTextField="Count" HeaderText="Count">
                                        <ItemStyle HorizontalAlign="Center" Width="20%" />
                                        <HeaderStyle Height="20%" HorizontalAlign="Center" />
                                    </asp:HyperLinkField>
                                </Columns>
                                <RowStyle BackColor="#EFF3FB" />
                                <EditRowStyle BackColor="#2461BF" />
                                <SelectedRowStyle BackColor="#D1DDF1" Font-Bold="True" ForeColor="#333333" />
                                <PagerStyle BackColor="#2461BF" ForeColor="White" HorizontalAlign="Center" />
                                <HeaderStyle BackColor="#507CD1" Font-Bold="True" ForeColor="White" />
                                <AlternatingRowStyle BackColor="White" />
                            </asp:GridView><asp:Label ID="lblPermissionNone" runat="server" Text="None"></asp:Label>
                        </td>
                        </tr>
                     </table>
                    </td>
                </tr>
                <tr>
                    <td>
                     <table cellpadding="5" cellspacing="1" width="100%" style="font-size: 10pt; font-family: Verdana;border:solid 1px black">
                        <tr>
                        <td align=center class="titleTD">
                            Organization Assignments
                        </td>
                        </tr>
                        <tr>
                        <td>
                            <asp:GridView ID="gvOrganizationAssignments" runat="server" AutoGenerateColumns="False"
                                CellPadding="4" EmptyDataText="None" ForeColor="#333333" GridLines="None" Width="100%">
                                <RowStyle BackColor="#EFF3FB" />
                                <EditRowStyle BackColor="#2461BF" />
                                <SelectedRowStyle BackColor="#D1DDF1" Font-Bold="True" ForeColor="#333333" />
                                <PagerStyle BackColor="#2461BF" ForeColor="White" HorizontalAlign="Center" />
                                <HeaderStyle BackColor="#507CD1" Font-Bold="True" ForeColor="White" />
                                <AlternatingRowStyle BackColor="White" />
                                <FooterStyle BackColor="#507CD1" Font-Bold="True" ForeColor="White" />
                                <Columns>
                                    <asp:HyperLinkField DataNavigateUrlFields="Name" DataNavigateUrlFormatString="?name={0}&amp;taskAssignmentType=OrgUnit"
                                        DataTextField="Name" HeaderText="Name">
                                        <ItemStyle HorizontalAlign="Left" Width="80%" />
                                        <HeaderStyle HorizontalAlign="Left" Width="80%" />
                                    </asp:HyperLinkField>
                                    <asp:HyperLinkField DataNavigateUrlFields="Name" DataNavigateUrlFormatString="?name={0}&amp;taskAssignmentType=OrgUnit"
                                        DataTextField="Count" HeaderText="Count">
                                        <ItemStyle HorizontalAlign="Center" Width="20%" />
                                        <HeaderStyle HorizontalAlign="Center" Width="20%" />
                                    </asp:HyperLinkField>
                                </Columns>
                            </asp:GridView><asp:Label ID="lblOrganizationNone" runat="server" Text="None"></asp:Label>
                        </td>
                        </tr>
                     </table>
                    </td>
                </tr>
                <tr>
                    <td>
                     <table cellpadding="5" cellspacing="1" width="100%" style="font-size: 10pt; font-family: Verdana;border:solid 1px black">
                        <tr>
                        <td align=center class="titleTD">
                            Queue Assignments
                        </td>
                        </tr>
                        <tr>
                        <td>
                            <asp:GridView ID="gvQueueAssignments" runat="server" AutoGenerateColumns="False"
                                CellPadding="4" EmptyDataText="None" ForeColor="#333333" GridLines="None" Width="100%">
                                <Columns>
                                    <asp:HyperLinkField DataNavigateUrlFields="Name" DataNavigateUrlFormatString="?name={0}&amp;taskAssignmentType=Queue"
                                        DataTextField="Name" HeaderText="Name">
                                        <ItemStyle Width="80%" />
                                        <HeaderStyle Width="80%" HorizontalAlign="Left" />
                                    </asp:HyperLinkField>
                                    <asp:HyperLinkField DataNavigateUrlFields="Name" DataNavigateUrlFormatString="?name={0}&amp;taskAssignmentType=Queue"
                                        DataTextField="Count" HeaderText="Count">
                                        <ItemStyle HorizontalAlign="Center" Width="20%" />
                                        <HeaderStyle HorizontalAlign="Center" Width="20%" />
                                    </asp:HyperLinkField>
                                </Columns>
                                <FooterStyle BackColor="#507CD1" Font-Bold="True" ForeColor="White" />
                                <RowStyle BackColor="#EFF3FB" />
                                <EditRowStyle BackColor="#2461BF" />
                                <SelectedRowStyle BackColor="#D1DDF1" Font-Bold="True" ForeColor="#333333" />
                                <PagerStyle BackColor="#2461BF" ForeColor="White" HorizontalAlign="Center" />
                                <HeaderStyle BackColor="#507CD1" Font-Bold="True" ForeColor="White" />
                                <AlternatingRowStyle BackColor="White" />
                            </asp:GridView><asp:Label ID="lblQueueNone" runat="server" Text="None"></asp:Label>
                        </td>
                        </tr>
                     </table>
                    </td>
                </tr>
            </table>
        </ContentTemplate>
        <Triggers>
            <asp:AsyncPostBackTrigger ControlID="refreshTimer" EventName="Tick" />
        </Triggers>
        </asp:UpdatePanel>
        <asp:Panel ID="pnlTaskList" runat="server">
                <table cellpadding="3" style="width: 100%">
                <tr>
                <td align="center">
                <b>Task List for <asp:Label ID="lblTaskAssignmentType" runat="server"></asp:Label> : <asp:Label ID="lblName" runat="server"></asp:Label></b>
                </td>
                </tr>
            <tr>
                <td>
        <asp:GridView ID="gvTaskList"  runat="server" AutoGenerateColumns="False" CellPadding="4" ForeColor="#333333" GridLines="None" Width="100%" Font-Names="Verdana" Font-Size="12px" OnRowDataBound="gvTaskList_RowDataBound">
                        <Columns>                            
                           <asp:BoundField  datafield="TaskName"  headertext="Task Name"/>
                             <asp:BoundField datafield="ComponentName"  headertext="Component Name"/>
                              <asp:BoundField datafield="TaskTypeID"  headertext="Task Type"/>
                              <asp:BoundField datafield="CreatedBy"  headertext="Project"/> 
                            <asp:TemplateField HeaderText="View">
                                <ItemTemplate>
                                    <asp:HyperLink ID="hlViewLink" runat="server" NavigateUrl='<%# Eval("TaskID", "?TaskID={0}") %>'
                                        Text="View"></asp:HyperLink>
                                </ItemTemplate>
                            </asp:TemplateField>
                                                    
                        </Columns>
                        <RowStyle BackColor="#EFF3FB" />
                        <EditRowStyle BackColor="#2461BF" />
                        <SelectedRowStyle BackColor="#D1DDF1" Font-Bold="True" ForeColor="#333333" />
                        <PagerStyle BackColor="#2461BF" ForeColor="White" HorizontalAlign="Center" />
                        <HeaderStyle BackColor="#507CD1" Font-Bold="True" ForeColor="White" HorizontalAlign="Left" />
                        <AlternatingRowStyle BackColor="White" /><FooterStyle BackColor="#507CD1" Font-Bold="True" ForeColor="White" />
                    </asp:GridView></td>
                    </tr>
                    <tr>
                    <td>
                    <asp:HyperLink ID="lbBackToStats" runat="server" Text="Back to Main Page" NavigateUrl="?"></asp:HyperLink> | 
                    <asp:HyperLink ID="hlBackToCurrentProcesses" Visible="false" runat="server" Text="Back to Current Processes" NavigateUrl="?TaskAssignmentType=CurrentProcesses"></asp:HyperLink>
                    </td>
                    </tr>
                    </table>
        </asp:Panel>
        <asp:UpdatePanel ID="updPnlTaskDetails" runat="server" RenderMode="Inline">
        <ContentTemplate>
        <table width="100%" border="1" cellpadding="3" cellspacing="0" bordercolor="#000000" bgcolor="#2165a5">
        <tr>
        <td>
            <table cellpadding="4" cellspacing="1" style="width: 100%" bgcolor="#ffffff">
                <tr>
                    <td width="20%" class="fieldTitleTD">
                        Task Name :</td>
                    <td >
                        <asp:Label ID="lblTaskName" runat="server"></asp:Label></td>
                </tr>
                <tr>
                    <td class="fieldTitleTD">
                        Task Description :</td>
                    <td >
                        <asp:Label ID="lblTaskDescription" runat="server"></asp:Label></td>
                </tr>
                <tr>
                    <td class="fieldTitleTD">
                        Model Name :</td>
                    <td >
                        <asp:Label ID="lblModelName" runat="server"></asp:Label></td>
                </tr>
                <tr>
                    <td class="fieldTitleTD">
                        Component Name :</td>
                    <td >
                        <asp:Label ID="lblComponentName" runat="server"></asp:Label></td>
                </tr>
                <tr>
                    <td class="fieldTitleTD">
                        Task Priority :</td>
                    <td >
                        <asp:Label ID="lblTaskPriority" runat="server"></asp:Label></td>
                </tr>
                <tr>
                    <td class="fieldTitleTD">
                        Task Type :</td>
                    <td >
                        <asp:Label ID="lblTaskType" runat="server"></asp:Label></td>
                </tr>
                <tr>
                    <td class="fieldTitleTD">
                        Tracking ID :</td>
                    <td >
                        <asp:Label ID="lblTrackingID" runat="server"></asp:Label>
                        <asp:HyperLink ID="hlViewTrackingTasks" runat="server">[View Current Tasks]</asp:HyperLink></td>
                </tr>
                <tr>
                    <td class="fieldTitleTD">
                        Task ID :</td>
                    <td >
                        <asp:Label ID="lblTaskID" runat="server"></asp:Label></td>
                </tr>
                <tr>
                    <td class="fieldTitleTD">
                        Project :</td>
                    <td >
                        <asp:Label ID="lblProject" runat="server"></asp:Label></td>
                </tr>
                <tr>
                    <td class="fieldTitleTD">
                        Due Date :</td>
                    <td >
                        <asp:Label ID="lblDueDate" runat="server"></asp:Label></td>
                </tr>
                <tr>
                    <td class="fieldTitleTD">
                        Late Date :</td>
                    <td >
                        <asp:Label ID="lblLateDate" runat="server"></asp:Label></td>
                </tr>
                <tr>
                    <td class="fieldTitleTD">
                        Postpone Timeout :</td>
                    <td>
                        <asp:TextBox ID="txtTimeoutTime" runat="server"></asp:TextBox>
                        <asp:CompareValidator ID="CompareValidator1" runat="server" ControlToValidate="txtTimeoutTime"
                            ErrorMessage="Invalid Date" Operator="DataTypeCheck" Type="Date"></asp:CompareValidator>
                        <asp:Button ID="btnPostpone" runat="server" OnClick="btnPostpone_Click" Text="Postpone" /></td>
                </tr>
                <tr>
                    <td class="fieldTitleTD" valign="top" style="height: 168px">
                        Responses :</td>
                    <td>
                        <asp:GridView ID="gvResponses" runat="server" CellPadding="4" ForeColor="#333333"
                            GridLines="None" AutoGenerateColumns="False" Width="100%">
                            <FooterStyle BackColor="#507CD1" Font-Bold="True" ForeColor="White" />
                            <RowStyle BackColor="#EFF3FB" />
                            <EditRowStyle BackColor="#2461BF" />
                            <SelectedRowStyle BackColor="#D1DDF1" Font-Bold="True" ForeColor="#333333" />
                            <PagerStyle BackColor="#2461BF" ForeColor="White" HorizontalAlign="Center" />
                            <HeaderStyle BackColor="#507CD1" Font-Bold="True" ForeColor="White" HorizontalAlign="Left" />
                            <AlternatingRowStyle BackColor="White" />
                            <Columns>
                                <asp:BoundField DataField="Type" HeaderText="Type" />
                                <asp:HyperLinkField DataNavigateUrlFields="URL" DataTextField="URL" HeaderText="URL"
                                    Target="_blank" />
                            </Columns>
                        </asp:GridView>
                    </td>    
                </tr>
                 <tr>
                    <td class="fieldTitleTD" valign="top">
                        Assignments :</td>
                    <td >
                        <asp:GridView ID="gvAssignments" runat="server" CellPadding="4" ForeColor="#333333"
                            GridLines="None" AutoGenerateColumns="False" OnRowDeleting="gvAssignments_RowDeleting" Width="100%" OnRowDataBound="gvAssignments_RowDataBound">
                            <FooterStyle BackColor="#507CD1" Font-Bold="True" ForeColor="White" />
                            <RowStyle BackColor="#EFF3FB" />
                            <EditRowStyle BackColor="#2461BF" />
                            <SelectedRowStyle BackColor="#D1DDF1" Font-Bold="True" ForeColor="#333333" />
                            <PagerStyle BackColor="#2461BF" ForeColor="White" HorizontalAlign="Center" />
                            <HeaderStyle BackColor="#507CD1" Font-Bold="True" ForeColor="White" HorizontalAlign="Left" />
                            <AlternatingRowStyle BackColor="White" />
                            <Columns>
                                <asp:BoundField DataField="AssignmentType" HeaderText="Type" />
                                <asp:BoundField DataField="AssignTo" HeaderText="Assigned To" />
                                <asp:CommandField ShowDeleteButton="True" DeleteText="Remove" />
                            </Columns>
                        </asp:GridView>
                        </td>
                </tr>
                 <tr>
        <td>&nbsp;</td>
        <td>
        <table border="0" cellpadding="4" cellspacing="1" width="100%">
        <tr>
        <td colspan="2" class="titleTD">
        Add Assignment
        </td>
        </tr>
        <tr>
        <td width="25%" class="fieldTitleTD">
            Type :</td>
        <td>
            <asp:DropDownList ID="ddlAssignmentType" runat="server">
            </asp:DropDownList></td>
        </tr>
            <tr>
                <td class="fieldTitleTD">
                    Name :</td>
                <td>
                    <asp:TextBox ID="txtName" runat="server"></asp:TextBox>
                    </td>
            </tr>
            <tr>
                <td colspan="2" align="center">
                    <asp:Button ID="btnAdd" runat="server" Text="Add" OnClick="btnAdd_Click" /></td>
            </tr>
        </table>
        </td>
        </tr>
                <tr>
                    <td class="fieldTitleTD" valign="top"> 
                        Triggers :</td>
                    <td>
                        <asp:GridView ID="gvTriggers" runat="server" CellPadding="4" ForeColor="#333333"
                            GridLines="None" AutoGenerateColumns="False" Width="100%" OnRowDeleting="gvTriggers_RowDeleting" OnRowCommand="gvTriggers_RowCommand" >
                            <FooterStyle BackColor="#507CD1" Font-Bold="True" ForeColor="White" />
                            <Columns>
                                <asp:BoundField DataField="Sequence" HeaderText="Sequence" />
                                <asp:BoundField DataField="TriggerType" HeaderText="Type" />
                                <asp:BoundField DataField="TriggerTime" HeaderText="Trigger Time" />
                                <asp:BoundField DataField="Processed" HeaderText="Processed" />
                                <asp:CommandField ShowDeleteButton="True" DeleteText="Remove" />
                                <asp:ButtonField CommandName="ChangeTiming" Text="Change Timing" />
                            </Columns>
                            <RowStyle BackColor="#EFF3FB" />
                            <EditRowStyle BackColor="#2461BF" />
                            <SelectedRowStyle BackColor="#D1DDF1" Font-Bold="True" ForeColor="#333333" />
                            <PagerStyle BackColor="#2461BF" ForeColor="White" HorizontalAlign="Center" />
                            <HeaderStyle BackColor="#507CD1" Font-Bold="True" ForeColor="White" HorizontalAlign="Left" />
                            <AlternatingRowStyle BackColor="White" />
                        </asp:GridView>
                    </td>
                </tr>
                <tr>
                    <td class="fieldTitleTD" valign="top">
                    </td>
                    <td>
                        New Trigger Time:
                        <asp:TextBox ID="txtNewTriggerTime" runat="server"></asp:TextBox>
                        <asp:CompareValidator ID="CompareValidator2" runat="server" ControlToValidate="txtNewTriggerTime"
                            ErrorMessage="Invalid Date" Operator="DataTypeCheck" Type="Date"></asp:CompareValidator></td>
                </tr>
                <tr>
                    <td class="fieldTitleTD" valign="top">
                    </td>
                    <td align="right">
                        <asp:LinkButton ID="lbRemoveAllTriggers" runat="server" OnClick="lbRemoveAllTriggers_Click">Remove All Triggers</asp:LinkButton></td>
                </tr>
        <tr>
        <td colspan="2">
        <asp:HyperLink ID="hlBackToStats2" runat="server" Text="Back to Main Page" NavigateUrl="?"></asp:HyperLink> | <asp:HyperLink ID="hlBackToList" runat="server" Text="Back to Task List" NavigateUrl="?"></asp:HyperLink>
        </td>
        </tr>
        
            </table>
        </td>
        </tr>
       
        </table>
        </ContentTemplate>
        </asp:UpdatePanel>
        <asp:Panel id="pnlCurrentProcesses" runat="server">
        <table cellpadding="3" style="width: 100%">
                <tr>
                <td align="center">
                <b>Current Processes</b>
                </td>
                </tr>
            <tr>
                <td>
                    <asp:GridView ID="gvCurrentProcesses" runat="server" AutoGenerateColumns="False" CellPadding="4"
                        ForeColor="#333333" GridLines="None" OnRowDataBound="gvCurrentProcesses_RowDataBound" Width="100%">
                        <FooterStyle BackColor="#507CD1" Font-Bold="True" ForeColor="White" />
                        <Columns>
                            <asp:BoundField DataField="StartedDateTime" HeaderText="Started" >
                                <ItemStyle Width="200px" />
                            </asp:BoundField>
                            <asp:BoundField DataField="TrackingID" HeaderText="Tracking ID"  />
                            <asp:TemplateField HeaderText="No of Tasks">
                            <ItemTemplate>
                            <asp:Label id="lblNoOfTasks" runat="server"></asp:Label>
                            </ItemTemplate>
                            </asp:TemplateField>
                            <asp:HyperLinkField DataNavigateUrlFields="TrackingID" DataNavigateUrlFormatString="?TrackingID={0}"
                                HeaderText="View Tasks" Text="View Tasks" />
                            <asp:HyperLinkField DataNavigateUrlFields="TrackingID" DataNavigateUrlFormatString="?HistoryTrackingID={0}"
                                HeaderText="View History" Text="Execution History" />
                            <asp:HyperLinkField DataNavigateUrlFields="TrackingID" DataNavigateUrlFormatString="?AbortTrackingID={0}"
                                HeaderText="Abort Workflow" Text="Abort" />
                        </Columns>
                        <RowStyle BackColor="#EFF3FB" />
                        <EditRowStyle BackColor="#2461BF" />
                        <SelectedRowStyle BackColor="#D1DDF1" Font-Bold="True" ForeColor="#333333" />
                        <PagerStyle BackColor="#2461BF" ForeColor="White" HorizontalAlign="Center" />
                        <HeaderStyle BackColor="#507CD1" Font-Bold="True" ForeColor="White" HorizontalAlign="Left" />
                        <AlternatingRowStyle BackColor="White" />
                    </asp:GridView>
                </td>
                </tr>
                <tr>
                    <td>
                    <asp:HyperLink ID="hlBackToStats3" runat="server" Text="Back to Main Page" NavigateUrl="?"></asp:HyperLink>
                    </td>
                    </tr>
                </table>
        </asp:Panel>
        <asp:Panel ID="pnlExecutionHistory" runat="server">
        <table cellpadding="3" style="width: 100%">
                <tr>
                <td align="center">
                <b>Execution History for Tracking ID : <asp:Label ID="lblHistoryTrackingID" runat="server"></asp:Label></b>
                </td>
                </tr>
            <tr>
                <td>
                    <asp:GridView ID="gvExecutionHistory" runat="server" AutoGenerateColumns="False"
                        CellPadding="4" ForeColor="#333333" GridLines="None" Width="100%" OnRowDataBound="gvExecutionHistory_RowDataBound">
                        <FooterStyle BackColor="#507CD1" Font-Bold="True" ForeColor="White" />
                        <Columns>
                            <asp:BoundField HeaderText="When" ItemStyle-Wrap="false" />
                            <asp:BoundField HeaderText="Component Name" />
                            <asp:BoundField HeaderText="Event Type" />
                            <asp:BoundField HeaderText="Finished Path" />
                            <asp:BoundField HeaderText="Description" />
                        </Columns>
                        <RowStyle BackColor="#EFF3FB" />
                        <EditRowStyle BackColor="#2461BF" />
                        <SelectedRowStyle BackColor="#D1DDF1" Font-Bold="True" ForeColor="#333333" />
                        <PagerStyle BackColor="#2461BF" ForeColor="White" HorizontalAlign="Center" />
                        <HeaderStyle BackColor="#507CD1" Font-Bold="True" ForeColor="White" />
                        <AlternatingRowStyle BackColor="White" />
                    </asp:GridView>
                    
                </td>
                </tr>
                <tr>
                    <td>
                    <asp:HyperLink ID="hlBackToStats4" runat="server" Text="Back to Main Page" NavigateUrl="?"></asp:HyperLink> | 
                    <asp:HyperLink ID="hlBackToCurrentProcess2" runat="server" Text="Back to Current Process List" NavigateUrl="?TaskAssignmentType=CurrentProcesses"></asp:HyperLink>
                    </td>
                    </tr>
                </table>
        </asp:Panel>
        <asp:Panel ID="pnlInactiveWorkflow" runat=server>
        <table cellpadding="3" style="width: 100%">
                <tr>
                <td align="center">
                <b>Inactive Workflow Tasks of type : <asp:Label ID="lblInactiveWorkflowType" runat="server"></asp:Label></b>
                </td>
                </tr>
            <tr>
                <td>
                    <asp:GridView ID="gvInactiveWorkflow" runat="server" AutoGenerateColumns="False"
                        CellPadding="4" ForeColor="#333333" GridLines="None" Width="100%" OnRowDataBound="gvInactiveWorkflow_RowDataBound">
                        <FooterStyle BackColor="#507CD1" Font-Bold="True" ForeColor="White" />
                        <Columns>
                            <asp:BoundField HeaderText="Archive DateTime" />
                            <asp:BoundField HeaderText="Details" />
                            <asp:BoundField HeaderText="Last Component Name" />
                            <asp:BoundField HeaderText="Last Model Name" />
                            <asp:BoundField HeaderText="Is Restartable" />
                        </Columns>
                        <RowStyle BackColor="#EFF3FB" />
                        <EditRowStyle BackColor="#2461BF" />
                        <SelectedRowStyle BackColor="#D1DDF1" Font-Bold="True" ForeColor="#333333" />
                        <PagerStyle BackColor="#2461BF" ForeColor="White" HorizontalAlign="Center" />
                        <HeaderStyle BackColor="#507CD1" Font-Bold="True" ForeColor="White" />
                        <AlternatingRowStyle BackColor="White" />
                    </asp:GridView>
                    
                </td>
                </tr>
                <tr>
                    <td>
                    <asp:HyperLink ID="hlBackToStats5" runat="server" Text="Back to Main Page" NavigateUrl="?"></asp:HyperLink></td>
                    </tr>
                </table>
        </asp:Panel>
        
    </form>
</body>
</html>
